unit AddonUtils;

{ <WoW Addon-Updater>
  <Unit Addon Utils - Fuctions to list AddOn-Sites in WWW>

  Copyright (C) <2016> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, FileUtil, Dialogs, FileOperations;

procedure SetUserAgent;

function GetAddonName(url: string): string;
function GetAddonVersion(url: string): string;
function GetAddonVersionElv(url: string): string;
function GetAddonURL(url: string): string;
function GetAddonChanges(url: string): string;

function DownloadFile(DownloadUrl, TargetDir: string): string;
function UpdateAddon(url, AddonDir: string): boolean;

implementation

procedure SetUserAgent;
begin

end;


// Some Test-Procedures that only give Return values back

function GetAddonName(url: string): string;
begin
  Randomize;
  Result := 'Addon-Name ' + IntToStr(Random(100));
end;

function GetAddonVersion(url: string): string;
begin
  Result := '1.0.0';
end;

function GetAddonVersionElv(url: string): string;
begin
  Result := '2.0.0';
end;

function GetAddonURL(url: string): string;
begin
  Result := 'http://www.url.tld';
end;

function GetAddonChanges(url: string): string;
begin
  Result := 'Änderungsinformationen.';
end;

function DownloadFile(DownloadUrl, TargetDir: string): string;
begin
  Result := 'Dateiname';
end;

function UpdateAddon(url, AddonDir: string): boolean;
begin
  Result := True
end;

end.

