{%mainunit uaddnew.pas}

{ <Include-File for uAddNew - Section Functions for Main-Form>
  <WoW Addon-Updater>

  Copyright (C) <2018> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

procedure frmAddNewReset; // Reset Form to Standard Values
begin
with frmAddNew do begin
  SelEntries := 0; // Startvalue for Selected Entries in StringGrid
  txtSearch.Color := clDefault;

  // Delete existing search results
  with StringGridResult do begin
    Clear;
    RowCount := RowCount + 1;
  end;

  lblResults.Caption := '';
  cmdAddAll.Enabled := false;
end;
end;


procedure frmAddNewSearchEnabled(S: boolean); // Turn Searchbox and Stringgrid on/off
begin
with frmAddNew do begin
  case S of
    true: begin
      grpSearch.Enabled:=true;
      cmdSearch.Enabled:=true;
      txtSearch.Enabled:=true;
      chkDirectURL.Enabled:=true;
      grpResult.Enabled:=true;
      StringGridResult.Enabled:=true;
      lblResults.Enabled:=true;
      if SelEntries > 0 then
        cmdAddAll.Enabled := true
      else
        cmdAddAll.Enabled := false;
    end;

    false: begin
      grpSearch.Enabled:=false;
      cmdSearch.Enabled:=false;
      txtSearch.Enabled:=false;
      chkDirectURL.Enabled:=false;
      grpResult.Enabled:=false;
      StringGridResult.Enabled:=false;
      lblResults.Enabled:=false;
      cmdAddAll.Enabled:=false;
    end;
  end;
end;

end;


procedure TfrmAddNew.FormActivate(Sender: TObject);
begin
  // Set Language
  frmAddNew.Caption := LangMnuAddAddon;
  grpSearch.Caption := LangAddNewGrpSearch;
  chkDirectURL.Caption := LangAddNewChkDirectUrl;
  chkSearchEng.Caption := LangAddNewChkSearchEng;
  chkSearchEng.Hint := LangAddNewChkSearchEngHint;
  cmdSearch.Caption := LangAddNewCmdSearch;
  RadioGroup1.Caption := LangAddNewRadioGroup1;
  grpResult.Caption := LangAddNewGrpResult;
  grpAddNew.Caption := LangAddNewGrpAddNew;
  ListBox1.Hint := LangAddNewListBox1Hint;

  // Initialize Formular
  grpSizeSpacing := Splitter1.Width +  (2 * grpAddNew.BorderSpacing.Around) + (2 * grpResult.BorderSpacing.Around);
  frmAddNewReset; // Reset Form to Standard Values
  RadioGroup1.ItemIndex := 0;
  frmAddNewSearchEnabled(true); // Turn Searchbox and Stringgrid on
  lblAddNew.Caption := '';
  ListBox1.Clear;
end;


procedure TfrmAddNew.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if ModalResult = mrCancel then begin
    Form1.AddNewResult := false;
    CanClose := true
  end
  else if (ModalResult = mrOk) and (ListBox1.Items.Count > 0) then begin
    Form1.AddonUrlList.Assign(ListBox1.Items);
    Form1.AddNewResult := true;
    CanClose := true
  end
  else
    CanClose := false;
end;


procedure TfrmAddNew.FormResize(Sender: TObject);
begin
  if (grpAddNew.Left + grpAddNew.Width + grpAddNew.BorderSpacing.Around) > frmAddNew.Width then
    grpResult.Width := frmAddNew.Width - (grpAddNew.Width + grpSizeSpacing);
end;


