{%mainunit uaddnew.pas}

{ <Include-File for uAddNew - Section Functions for Search Result List>
  <WoW Addon-Updater>
  
  Copyright (C) <2018> <Arndt Braier> <dev@braier.net>
  
  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

procedure TfrmAddNew.StringGridResultPrepareCanvas(sender: TObject; aCol,
    aRow: Integer; aState: TGridDrawState);
begin
  // Visualisation options for Grid (Colors and Font-Weight)

  // Separate every second line in gray color
  if (ACol > 0) And (ARow > 0) And (ARow mod 2 = 0) then
    StringGridResult.Canvas.Brush.Color := clBtnFace;

  // Selected = Font Bold
  if StringGridResult.Cells[1, ARow] = '1' then
    StringGridResult.Canvas.Font.Style := [fsBold];

  // Selected row with blue background and white text
  if (gdSelected in aState) or (gdFocused in aState) then begin
    StringGridResult.Canvas.Brush.Color := clBlue;
    StringGridResult.Canvas.Font.Color := clWhite;
  end;
end;


// Left click: Toggle checkbox with row selection too
// Right click: Open Addon-URL in Webbrowser
procedure TfrmAddNew.StringGridResultMouseDown(Sender: TObject;
    Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  iCol: integer = 0;
  iRow: integer = 0;
  aURL: string;

begin
  if Button = mbLeft then begin
    with StringGridResult do
    begin
      MouseToCell(x,y,iCol,iRow);
      Col := iCol;
      Row := iRow;
      if (Col > 1) And (Row >= 1) then begin
        if Cells[1, Row] = '0' then begin
          Cells[1, Row] := '1';
          inc(SelEntries)
        end
        else if Cells[1, Row] = '1' then begin
          Cells[1, Row] := '0';
          dec(SelEntries);
        end;

        lblResults.Caption := IntToStr(SelEntries) + '/' + IntToStr(RowCount - 1) + LangAddNewlblResults;

        if SelEntries > 0 then
          cmdAddAll.Enabled := true
        else
          cmdAddAll.Enabled := false;
      end
    end
  end
  else if Button = mbRight then begin
    with StringGridResult do
    begin
      MouseToCell(x,y,iCol,iRow);
      Col := iCol;
      Row := iRow;
      if (Col > 1) And (Row >= 1) then begin
        aURL := Cells[3, Row];
        // Fix URL-Encoding (see RFC3986), replace space characters (#32) in URL by %20
        aURL := StringReplace(aURL, #32, #37 + '20', [rfReplaceAll]);
        OpenURL(aURL);
      end
    end
  end
end;


// Show cell hint (URL)
procedure TfrmAddNew.StringGridResultMouseMove(Sender: TObject;
    Shift: TShiftState; X, Y: Integer);
var
  ACol, ARow : Integer;

begin
  StringGridResult.MouseToCell(X, Y, ACol, ARow);
  StringGridResult.ShowHint := False;
  If (ARow > 0) AND (ACol = 2) then begin
    StringGridResult.ShowHint := True;
    StringGridResult.Hint := StringGridResult.Cells[3, ARow] + #13#10 + LangAddNewGrpResultHint;
  end;
end;


procedure TfrmAddNew.StringGridResultCheckboxToggled(sender: TObject; aCol,
    aRow: Integer; aState: TCheckboxState);
begin
  with StringGridResult do
  begin
    if Cells[1, Row] = '1' then
      inc(SelEntries)
    else if Cells[1, Row] = '0' then
      dec(SelEntries);

    lblResults.Caption := IntToStr(SelEntries) + '/' + IntToStr(RowCount - 1) + LangAddNewlblResults;

    if SelEntries > 0 then
      cmdAddAll.Enabled := true
    else
      cmdAddAll.Enabled := false;
  end
end;

