{%mainunit umain.pas}

{ <Include-File for uMain - Section FillOutAddonTable>
  <WoW Addon-Updater>

  Copyright (C) <2016> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

// Test-Procedure to fill out AddOn-Table with random values
procedure FillOutAddonTable;

// Explanation for Status-Column:
// ==========================================
// New     = New Addon or Update is available
// Updated = Addon was updated
// Ok      = No Update available (or needed)

var
    CurrRow: integer;
    NumberOfEntries, i, n: word;
    UserReq: string;

begin
  NumberOfEntries := 0;
  n := 1;
  UserReq := '';

  // Request from User, how much entries will be added.
  while NumberOfEntries <= 0 do begin
    InputQuery('Fill out Table with random stuff', 'How much Rows you want to add?', UserReq);
    If (UserReq = '') or (IsStringInteger(UserReq) = False) then begin
       NumberOfEntries := 0;
       Break
    end
    else
      NumberOfEntries := StrToInt(UserReq)
  end;

  // When User input was invalid, exit
  if NumberOfEntries = 0 then
    Exit;

  // Add Content to Table
  //  ShowMessage(IntToStr(NumberOfEntries));

  with Form1 do
  begin
    Randomize;
    // Check current row count
    CurrRow := StringGrid1.RowCount;
    ProgressBar1.Visible := true;
    ProgressBar1.Max := NumberOfEntries;
    ProgressBar1.Position := n;

    for CurrRow := CurrRow to (CurrRow + NumberOfEntries - 1) do begin
//        Application.ProcessMessages;
        // Now we would add a new Addon-Entry.
        // At first, jump to end of table and add a new row.
        StringGrid1.Row := StringGrid1.RowCount;
        StringGrid1.RowCount := StringGrid1.RowCount + 1;
        StringGrid1.Cells[0, CurrRow] := IntToStr(CurrRow);

        // Switch-Update checkbox to true or false
        StringGrid1.Cells[1, CurrRow] := IntToStr(Random(2));

        // Enter Addon-Data
        i := Random(5);
        case i of
           0:
             begin
             StringGrid1.Cells[2, CurrRow] := 'http://www.curse.com/addons/wow/deadly-boss-mods';
             StringGrid1.Cells[3, CurrRow] := 'Deadly Boss Mods';
             StringGrid1.Cells[5, CurrRow] := 'http://www.curse.com/addons/wow/deadly-boss-mods';
             StringGrid1.Cells[6, CurrRow] := 'Curse';
             end;
           1:
             begin
             StringGrid1.Cells[2, CurrRow] := 'http://www.curse.com/addons/wow/recount';
             StringGrid1.Cells[3, CurrRow] := 'Recount';
             StringGrid1.Cells[5, CurrRow] := 'http://www.curse.com/addons/wow/recount';
             StringGrid1.Cells[6, CurrRow] := 'Curse';
             end;
           2:
             begin
             StringGrid1.Cells[2, CurrRow] := 'http://www.curse.com/addons/wow/atlasloot-enhanced';
             StringGrid1.Cells[3, CurrRow] := 'AtlasLoot Enhanced';
             StringGrid1.Cells[5, CurrRow] := 'http://www.curse.com/addons/wow/atlasloot-enhanced';
             StringGrid1.Cells[6, CurrRow] := 'Curse';
             end;
           3:
             begin
             StringGrid1.Cells[2, CurrRow] := 'http://www.curse.com/addons/wow/titan-panel';
             StringGrid1.Cells[3, CurrRow] := 'Titan Panel';
             StringGrid1.Cells[5, CurrRow] := 'http://www.curse.com/addons/wow/titan-panel';
             StringGrid1.Cells[6, CurrRow] := 'Curse';
             end;
           4:
             begin
             StringGrid1.Cells[2, CurrRow] := 'http://git.tukui.org/Elv/elvui/';
             StringGrid1.Cells[3, CurrRow] := 'Elv / ElvUI';
             StringGrid1.Cells[5, CurrRow] := 'http://git.tukui.org/Elv/elvui/';
             StringGrid1.Cells[6, CurrRow] := 'ElvUI';
             end;
        end;

        StringGrid1.Cells[4, CurrRow] := IntToStr(Random(10)) + '.' + IntToStr(Random(10)) + '.' + IntToStr(Random(10)) + '.' + IntToStr(Random(10));

        i := Random(3);
        case i of
           0:
             StringGrid1.Cells[7, CurrRow] := 'New';
           1:
             StringGrid1.Cells[7, CurrRow] := 'Updated';
           2:
             StringGrid1.Cells[7, CurrRow] := 'Ok';
        end;

        // Now push the Progressbar
        Application.ProcessMessages;
        inc(n);
        ProgressBar1.Position := n;

    end;

    StringGrid1.Row := StringGrid1.RowCount;

    ProgressBar1.Visible := false;
    ProgressBar1.Position := 0;
    CalcListItems;
    StatusBar1.Panels[0].Text := StringGrid1.Cells[3, CurrRow] + LangStatAddFinish + ' ' + LangAddonsTotal + IntToStr(NumberOfItems);
  end;
end;


