{%mainunit umain.pas}

{ <Include-File for uMain - Section DoRemoveSelectedAddons>
  <WoW Addon-Updater>

  Copyright (C) <2016> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

procedure DoRemoveSelectedAddons;
var
  Count,
  TotalRows,
  CurrRow,
  MsgBoxDelReply,
  MsgBoxDelStyle: integer;

begin
   // At first, ask user for confirmation
   with Application do begin
       MsgBoxDelStyle := MB_ICONWARNING + MB_YESNO;
       MsgBoxDelReply := MessageBox(PChar(LangMsgBoxDelAddonText), PChar(LangMsgBoxDelAddonTitle), MsgBoxDelStyle);
       if MsgBoxDelReply = IDYES then begin
         // User say: Delete it, then we will do that now. Scan the List for Selections and delete the entries.
         with Form1 do
         begin
             Count := 0;
             CurrRow := 1;
             TotalRows := StringGrid1.RowCount - 1;

             // Create Logfile entry
             ActLogNewEntry('[' + LangMnuRemAddon + ']', LangStatActStart);

             for CurrRow := TotalRows downto 1 do begin
                 // If selected, delete it
                 if StringGrid1.Cells[1, CurrRow] = '1' then begin
                   // Create Logfile entries
                   ActLogNewEntry('  ' + LangStatRem, StringGrid1.Cells[3, CurrRow] + ' (' + StringGrid1.Cells[4, CurrRow] + ')');
                   ActLogNewEntry('    Addon-URL:', StringGrid1.Cells[2, CurrRow]);
                   ActLogNewEntry('    Download-URL:', StringGrid1.Cells[5, CurrRow]);
                   // Delete Row
                   GridDeleteRow(StringGrid1, CurrRow);
                   inc(Count);
                 end;
             end;
             CalcListItems;
             Form1.StatusBar1.Panels[0].Text := IntToStr(Count) + LangStatRemItem + IntToStr(NumberOfItems);

             // Create Logfile entries
             ActLogNewEntry('  ' + IntToStr(Count) + LangStatRemItem, IntToStr(NumberOfItems));
             ActLogNewEntry('[' + LangMnuRemAddon + ']', LangStatActEnd);
             ActLogSeparator; // Create separator line in logfile

             RenumberList;
             SaveDBToFile(StringGrid1);
         end;
       end;
   end;
end;


procedure DoRemoveSingleAddon;
var
  AddonName,
  MsgBoxDelTitle,
  MsgBoxDelText: string;
  CurrRow,
  MsgBoxDelReply,
  MsgBoxDelStyle: integer;

begin
   With Form1 do begin
     CurrRow := StringGrid1.Row;
     if CurrRow >= 1 then begin
       AddonName := StringGrid1.Cells[3, CurrRow];
       // At first, ask user for confirmation
       case MainLanguage of
       'de':
           MsgBoxDelTitle := AddonName + ' ' + LangPMnuRemAddon;
       'en':
           MsgBoxDelTitle := LangPMnuRemAddon + ' ' + AddonName;
       end;
       MsgBoxDelText := AddonName + ' (#' + IntToStr(CurrRow) + ')' + LangMsgBoxDelSingleAddonText;
       with Application do begin
         MsgBoxDelStyle := MB_ICONWARNING + MB_YESNO;
         MsgBoxDelReply := MessageBox(PChar(MsgBoxDelText), PChar(MsgBoxDelTitle + '?'), MsgBoxDelStyle);
         if MsgBoxDelReply = IDYES then begin
           // User say: Delete it, then we will do that now.

           // Create Logfile entry
           ActLogNewEntry('[' + MsgBoxDelTitle + ']', LangStatActStart);
           ActLogNewEntry('  ' + LangStatRem, StringGrid1.Cells[3, CurrRow] + ' (' + StringGrid1.Cells[4, CurrRow] + ')');
           ActLogNewEntry('    Addon-URL:', StringGrid1.Cells[2, CurrRow]);
           ActLogNewEntry('    Download-URL:', StringGrid1.Cells[5, CurrRow]);

           // Delete Row
           GridDeleteRow(StringGrid1, CurrRow);

           CalcListItems;
           StatusBar1.Panels[0].Text := '1' + LangStatRemItem + IntToStr(NumberOfItems);

           // Create Logfile entries
           ActLogNewEntry('  1' + LangStatRemItem, IntToStr(NumberOfItems));
           ActLogNewEntry('[' + MsgBoxDelTitle + ']', LangStatActEnd);
           ActLogSeparator; // Create separator line in logfile

           RenumberList;
           ResetFilter;   // Reset the Filter Settings
           SaveDBToFile(StringGrid1);
         end;
       end;
     end;
   end;
end;


