{%mainunit umain.pas}

{ <Include-File for uMain - Section Functions for Main-Form>
  <WoW Addon-Updater>

  Copyright (C) <2016-2018> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

function IsStringInteger(const AString: String): Boolean;
begin
  Result:=StrToIntDef(AString,0)=StrToIntDef(AString,1);
end;


procedure SaveUserConfig;
begin
    case GnomeAnimations of
    true:
      SetGnomeAnimations := 1;
    false:
      SetGnomeAnimations := 0;
    end;
    case DirectInstall of
    true:
      SetDirectInstall := 1;
    false:
      SetDirectInstall := 0;
    end;
    saveAppConfig(Form1.Left,
    Form1.Top,
    Form1.Height,
    Form1.Width,
    Form1.StringGrid1.ColWidths[1],
    Form1.StringGrid1.ColWidths[2],
    Form1.StringGrid1.ColWidths[3],
    Form1.StringGrid1.ColWidths[4],
    Form1.StringGrid1.ColWidths[5],
    Form1.StringGrid1.ColWidths[6],
    Form1.StringGrid1.ColWidths[7],
    SetGnomeAnimations,
    SetDirectInstall,
    MainLanguage,
    AddOnDir);
    Form1.StatusBar1.Panels[0].Text := LangStatSavedSettings;
end;


procedure ApplyLanguage;
begin
    SetLanguageSettings(MainLanguage);

    case MainLanguage of
    'de':
      begin
            Form1.mDE.Checked := True;
            Form1.mEN.Checked := False;
      end;
    'en':
      begin
            Form1.mDE.Checked := False;
            Form1.mEN.Checked := True;
      end;
    end;

    with Form1 do
    begin
      StatusBar2.Panels[0].Text := LangStatusbarAddonText + AddonDir;

      mFile.Caption := LangMnuFile;
      mOpenDB.Caption := LangMnuOpen;
      mSaveDB.Caption := LangMnuSaveDB;
      mExit.Caption := LangMnuQuit;
      mEdit.Caption:= LangMnuEdit;
      mSelectAddonDirectory.Caption := LangMnuSetAddonDir;
      mSaveOptions.Caption := LangMnuSaveSettings;
      mHelp.Caption := LangMnuHelp;
      mShorthelp.Caption := LangMnuShortHelp;
      mInfo.Caption := LangMnuInfo;
      mOptions.Caption := LangMnuOptions;
      mLanguage.Caption := LangMnuLanguage;
      mDE.Caption := LangMnuDE;
      mEN.Caption := LangMnuEN;
      mAddons.Caption := LangMnuAdd;
      mAddNewAddon.Caption := LangMnuAddAddon;
      cmdAddNewAddon.Hint := LangMnuAddAddon;
      mRemoveAddon.Caption := LangMnuRemAddon;
      cmdRemoveAddon.Hint := LangMnuRemAddon;
      mCheckForAddonUpdates.Caption := LangMnuChkAddUpd;
      cmdCheckForAddonUpdates.Hint := LangMnuChkAddUpd;
      mUpdateAddons.Caption := LangMnuUpdAdd;
      cmdUpdateAddons.Hint := LangMnuUpdAdd;
      mSelAll.Caption := LangMnuSelAll;
      mSelNone.Caption := LangMnuSelNone;
      mSortName.Caption := LangMnuSortName;
      cmdHelp.Hint := LangMnuShortHelp;
      cmdInfo.Hint := LangMnuInfo;
      mShowGnomeAnimations.Caption := LangMnuShowGnomeAnimations;
      mDirectInstall.Caption := LangMnuDirectInstall;

      lblAddNewAddon.Caption := LangDescAddAddon;
      lblRemoveAddon.Caption := LangDescRemAddon;
      lblCheckForAddonUpdates.Caption := LangDescChkAddUpd;
      lblUpdateAddons.Caption := LangDescUpdAdd;
      lblHelp.Caption := LangDescHelp;
      lblInfo.Caption := LangMnuInfo;

      grpExplanation.Caption := LangGrpExpl;
      lblNewVersionAvail.Caption := LangLblNewAvail;
      lblAddonUpdated.Caption := LangLblUpdated;
      lblUnchanged.Caption := LangLblUnchanged;
      lblError.Caption := LangLblError;

      SelectAddonDirectoryDialog.Title := LangSelAddonDirDialog;

      StringGrid1.Columns[0].Title.Caption := LangColSelect;
      StringGrid1.Columns[1].Title.Caption := LangColAddonUrl;
      StringGrid1.Columns[2].Title.Caption := LangColAddonName;
      StringGrid1.Columns[3].Title.Caption := LangColAddonVersion;
      StringGrid1.Columns[4].Title.Caption := LangColAddonDownloadUrl;
      StringGrid1.Columns[5].Title.Caption := LangColAddonSource;
      StringGrid1.Columns[6].Title.Caption := LangColAddonStatus;

      pmAddonChanges.Caption := LangPMnuAddonChanges;
      pmOpenWebsite.Caption := LangPMnuOpenWebsite;
      pmWebSearch.Caption := LangPMnuWebSearch;
      pmCheckForUpdate.Caption := LangPMnuChkAddUpd;
      pmUpdate.Caption := LangPMnuUpdAdd;
      pmRem.Caption := LangPMnuRemAddon;

      mFilter.Caption := LangMnuFilter;
      cmdFilter.Hint := LangLblFilter;
      lblFilter.Caption := LangLblFilter;
      grpFilter.Caption := LangGrpFilter;
      txtFilterText.Hint := LangFilterTextHint;
      txtFilterText.ButtonHint := LangFilterTextButtonHint;

      lblAttentionMain.Caption := LanglblAttentionMain;
      lblAttentionDesc.Caption := LanglblAttentionDesc;
      cmdConfirm.Caption := LangcmdConfirm;
    end;
end;


procedure DrawUpperGradient;
var
  colA, colB, colLine: TColor;

begin
  with Form1 do
  begin
    colA    := RGBtoColor(226,224,226);
    colB    := RGBtoColor(209,207,209);
    colLine := RGBtoColor(172,170,172);
//    imgGradient.Canvas.Clear;
    imgGradient.Picture.Bitmap.SetSize(imgGradient.Width,imgGradient.Height);
    imgGradient.Canvas.GradientFill(imgGradient.ClientRect,colA,colB,gdVertical);
    imgGradient.Canvas.Pen.Color := colLine;
    imgGradient.Canvas.Pen.Width := 2;
    imgGradient.Canvas.Line(0,imgGradient.Height,imgGradient.Width,imgGradient.Height);
  end;
end;

// #############################################################################
// End of specific functions/procedures - Start with Main-Form creation
// #############################################################################

procedure TForm1.FormCreate(Sender: TObject);
var
    WindowPosLeft,
    WindowPosTop,
    WindowHeight,
    WindowWidth,
    ColWidthA,
    ColWidthB,
    ColWidthC,
    ColWidthD,
    ColWidthE,
    ColWidthF,
    ColWidthG,
    SetGnomeAnimations,
    SetDirectInstall,
    MsgBoxLangStyle,
    MsgBoxLangReply: integer;
    Language,
    AppDataPath: string;

begin
    inherited;
    // Initialization of variables, will be overwritten by load procedure ...
    WindowPosLeft := 1;
    WindowPosTop := 1;
    WindowHeight := 10;
    WindowWidth := 10;
    ColWidthA := 60;
    ColWidthB := 175;
    ColWidthC := 125;
    ColWidthD := 75;
    ColWidthE := 150;
    ColWidthF := 150;
    ColWidthG := 75;
    SetGnomeAnimations := 1;
    SetDirectInstall := 1;
    Language := 'en';
    AppDataPath := 'not defined';

    loadAppConfig(
        WindowPosLeft,
        WindowPosTop,
        WindowHeight,
        WindowWidth,
        ColWidthA,
        ColWidthB,
        ColWidthC,
        ColWidthD,
        ColWidthE,
        ColWidthF,
        ColWidthG,
        SetGnomeAnimations,
        SetDirectInstall,
        Language,
        AppDataPath);

    Form1.Left := WindowPosLeft;
    Form1.Top := WindowPosTop;
    Form1.Height := WindowHeight;
    Form1.Width := WindowWidth;

    StringGrid1.ColWidths[1] := ColWidthA;
    StringGrid1.ColWidths[2] := ColWidthB;
    StringGrid1.ColWidths[3] := ColWidthC;
    StringGrid1.ColWidths[4] := ColWidthD;
    StringGrid1.ColWidths[5] := ColWidthE;
    StringGrid1.ColWidths[6] := ColWidthF;
    StringGrid1.ColWidths[7] := ColWidthG;

    if SetGnomeAnimations = 0 then begin
        GnomeAnimations := false;
        mShowGnomeAnimations.Checked := false
    end
    else begin
        GnomeAnimations := true;
        mShowGnomeAnimations.Checked := true
    end;

    if SetDirectInstall = 0 then begin
      DirectInstall := false;
      mDirectInstall.Checked := false
    end
    else begin
      DirectInstall := true;
      mDirectInstall.Checked := true
    end;

    MainLanguage := Language;
    ApplyLanguage;

    // Check if First AddonDir Configuration is done and execute Selection Dialog, if not
    AddonDir := AppDataPath;

    while AddonDir = 'not defined' do begin
        // First-Start Language selection
          with Application do begin
            MsgBoxLangStyle :=  MB_ICONQUESTION + MB_YESNO;
            MsgBoxLangReply :=  MessageBox ('Do you want to continue in English, ' +
            'select "Yes". If you want Deutsch/German, press "No" (um das ' +
            'Programm in deutscher Sprache fortzuführen, drücken Sie bitte ' +
            '"No").', 'Language selection', MsgBoxLangStyle);
            if MsgBoxLangReply = IDYES then MainLanguage := 'en'
            else MainLanguage := 'de'
          end;

          ApplyLanguage;

          MessageDlg('First Start', LangFirstStart, mtInformation, [mbOK], 0);

          if SelectAddonDirectoryDialog.Execute then
              AddonDir := SelectAddonDirectoryDialog.Filename;
          SaveUserConfig;
    end;

    StatusBar1.Panels[0].Width := Form1.Width div 2;
    StatusBar1.Panels[1].Width := StatusBar1.Panels[0].Width;
    ProgressBar1.Width := StatusBar1.Panels[1].Width - 30;

    StatusBar2.Panels[0].Text := LangStatusbarAddonText + AddonDir;

    // Load database (with error prevention for corrupt database)

    // Try to load DB ...
    try
      LoadDBFromFile(StringGrid1) // Load Database including StringGrid-Settings
    except
      // Database is corrupt, clear StringGrid and fill it with standard content
      StringGrid1.Clear;
      StringGrid1.Columns.Add;
      StringGrid1.RowCount := 1;
      StringGrid1.Columns.Delete(StringGrid1.ColCount-1);
      StringGrid1.FixedCols := 1;
      StringGrid1.FixedRows := 1;
      StringGrid1.Refresh;

      // Set standards for grid (size, language)
      StringGrid1.ColWidths[1] := ColWidthA;
      StringGrid1.ColWidths[2] := ColWidthB;
      StringGrid1.ColWidths[3] := ColWidthC;
      StringGrid1.ColWidths[4] := ColWidthD;
      StringGrid1.ColWidths[5] := ColWidthE;
      StringGrid1.ColWidths[6] := ColWidthF;
      StringGrid1.ColWidths[7] := ColWidthG;
      MainLanguage := Language;
      ApplyLanguage;

      // Process an Error-Message and save the DB
      MessageDlg('Error', LangErrorLoadDB, mtError, [mbOK], 0);
      CalcListItems;
      SaveDBToFile(StringGrid1);
    end;

    // Set StringGrid to standard values, against modifications from DB-file...
    StringGrid1.Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine, goDrawFocusSelected, goColSizing, goRowSelect, goDblClickAutoSize, goSmoothScroll];

    // Calculate Number of Addons
    CalcListItems;
    StatusBar1.Panels[0].Text := LangStatStart + IntToStr(NumberOfItems);

    // Deactivate Update Button and Menue-Entry (need Update Check before use)
    cmdUpdateAddons.Enabled := False;
    mUpdateAddons.Enabled := False;

    // Draw Gradient for ButtonBar-Background
    DrawUpperGradient;

    // Show Gnome-Animation :)
    if GnomeAnimations = true then
        TimerAniWave.Enabled := true;

    // Open Logfile and save entry
    ActLogLoad;
    ActLogNewEntry(LangStatLogStart, LangStatStart + IntToStr(NumberOfItems));
    ActLogSeparator; // Create separator line in logfile

    // Check, if DB-Upgrade necessary (e.g. after changes of Addon-Website)
    DBUpgradeCheck;
end;


procedure TForm1.FormResize(Sender: TObject);
begin
    // Draw Gradient for ButtonBar-Background
    DrawUpperGradient;

    StatusBar1.Panels[0].Width := Form1.Width div 2;
    StatusBar1.Panels[1].Width := StatusBar1.Panels[0].Width;
    ProgressBar1.Width := StatusBar1.Panels[1].Width - 30;
end;

procedure TForm1.imgGradientClick(Sender: TObject);
begin
  // when FilterBox is there, turn it off
  if panFilter.Visible = true then
    panFilter.Visible := false;
end;


procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
      UnfilterList(StringGrid1); // Remove Filter
      SaveDBToFile(StringGrid1);
      SaveUserConfig;
      ActLogNewEntry(LangStatLogEnd, ' ');
      ActLogProgEnd; // Save Logfile and clean up
end;


procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  // Don't exit program while CheckForUpdates or Update processes are running
  while TimerAniRun.Enabled = true do begin
    Application.ProcessMessages;
    CanClose := false;
  end;

  // Set Gnome-Animation before exit and close program after finishing
  if GnomeAnimations = true then
      TimerAniWave.Enabled := true;          // Start Gnome-Animation
  while TimerAniWave.Enabled = true do begin
    Application.ProcessMessages;
    CanClose := false;
  end;

  CanClose := true;
end;

