{%mainunit umain.pas}

{ <Include-File for uMain - Menue-Functions>
  <WoW Addon-Updater>

  Copyright (C) <2016-2018> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

// Menue File

procedure TForm1.mOpenDBClick(Sender: TObject);
begin
    LoadDBFromFile(StringGrid1);
    CalcListItems;
    StatusBar1.Panels[0].Text := LangStatLoadedDB + ' ' + LangAddonsTotal + IntToStr(NumberOfItems);
end;

procedure TForm1.mSaveDBClick(Sender: TObject);
begin
    CalcListItems;
    SaveDBToFile(StringGrid1);
    StatusBar1.Panels[0].Text := LangStatSavedDB + ' ' + LangAddonsTotal + IntToStr(NumberOfItems);
end;

procedure TForm1.mExitClick(Sender: TObject);
begin
    Form1.Close;
end;


// Menue Edit

procedure TForm1.mSelAllClick(Sender: TObject);
begin
    SelectAll;
end;

procedure TForm1.mSelNoneClick(Sender: TObject);
begin
    SelectNone;
end;

procedure TForm1.mSortNameClick(Sender: TObject);
begin
    SortAddonList('Name'); // Sort function accepts 3 parameters: 'Number', 'Name' and 'State'
    RenumberList // Renumber the index of complete list
end;

procedure TForm1.mFilterClick(Sender: TObject);
begin
    ShowFilterBox;
end;


// Menue "Addons"

procedure TForm1.mAddNewAddonClick(Sender: TObject);
begin
    DoAddNewAddon;
end;

procedure TForm1.mRemoveAddonClick(Sender: TObject);
begin
    DoRemoveSelectedAddons;
end;

procedure TForm1.mCheckForAddonUpdatesClick(Sender: TObject);
begin
    SaveSelections; // Save user-defined selections in Addon list
    DoCheckForAddonUpdates;
end;

procedure TForm1.mUpdateAddonsClick(Sender: TObject);
begin
    SaveSelections; // Save user-defined selections in Addon list
    DoUpdateAddons;
end;

procedure TForm1.pmAddonChangesClick(Sender: TObject);
begin
  with frmAddonChanges do begin
    Left := Form1.Left + ((Form1.Width - Width) DIV 2);
    Top := Form1.Top + ((Form1.Height - Height) DIV 2);
    ShowModal;
  end;
end;

procedure TForm1.pmOpenWebsiteClick(Sender: TObject);
begin
  OpenWebsite;
end;

procedure TForm1.pmWebSearchClick(Sender: TObject);
begin
  WebSearch;
end;

procedure TForm1.pmCheckForUpdateClick(Sender: TObject);
begin
  DoCheckForUpdateSingleAddon;
end;

procedure TForm1.pmRemClick(Sender: TObject);
begin
  DoRemoveSingleAddon;
end;

procedure TForm1.pmUpdateClick(Sender: TObject);
begin
  DoUpdateSingleAddon;
end;


// Menue Options

procedure TForm1.mDEClick(Sender: TObject);
begin
    MainLanguage := 'de';
    ApplyLanguage;
    SaveUserConfig;
end;

procedure TForm1.mENClick(Sender: TObject);
begin
    MainLanguage := 'en';
    ApplyLanguage;
    SaveUserConfig;
end;

procedure TForm1.mShowGnomeAnimationsClick(Sender: TObject);
begin
  if mShowGnomeAnimations.Checked = true then begin
    mShowGnomeAnimations.Checked := false;
    GnomeAnimations := false
  end
  else begin
    mShowGnomeAnimations.Checked := true;
    GnomeAnimations := true
  end;
  SaveUserConfig;
end;

procedure TForm1.mDirectInstallClick(Sender: TObject);
begin
  if mDirectInstall.Checked = true then begin
    mDirectInstall.Checked := false;
    DirectInstall := false;
  end
  else begin
    mDirectInstall.Checked := true;
    DirectInstall := true;
  end;
  SaveUserConfig;
end;

procedure TForm1.mSelectAddonDirectoryClick(Sender: TObject);
begin
    if SelectAddonDirectoryDialog.Execute then
        AddonDir := SelectAddonDirectoryDialog.Filename;
    StatusBar2.Panels[0].Text := LangStatusbarAddonText + AddonDir;
    StatusBar1.Panels[0].Text := LangStatSetDirectory;
end;

procedure TForm1.mSaveOptionsClick(Sender: TObject);
begin
    SaveUserConfig;
end;


// Menue Help

procedure TForm1.mShortHelpClick(Sender: TObject);
begin
  frmHelp.Left := Form1.Left + ((Form1.Width - frmHelp.Width) DIV 2);
  frmHelp.Top := Form1.Top + ((Form1.Height - frmHelp.Height) DIV 2);
  frmHelp.ShowModal;
end;

procedure TForm1.mInfoClick(Sender: TObject);

begin
  frmInfo.Left := Form1.Left + ((Form1.Width - frmInfo.Width) DIV 2);
  frmInfo.Top := Form1.Top + ((Form1.Height - frmInfo.Height) DIV 2);
  frmInfo.ShowModal;
end;

// Buttons

procedure TForm1.cmdAddNewAddonClick(Sender: TObject);
begin
    DoAddNewAddon;
end;

procedure TForm1.cmdRemoveAddonClick(Sender: TObject);
begin
    DoRemoveSelectedAddons;
end;

procedure TForm1.cmdCheckForAddonUpdatesClick(Sender: TObject);
begin
    DoCheckForAddonUpdates;
end;

procedure TForm1.cmdConfirmClick(Sender: TObject);
begin
    DBUpgrade;
end;

procedure TForm1.cmdUpdateAddonsClick(Sender: TObject);
begin
    DoUpdateAddons;
end;

procedure TForm1.cmdFilterClick(Sender: TObject);
begin
    ShowFilterBox;
end;

procedure TForm1.cmdHelpClick(Sender: TObject);
begin
  frmHelp.Left := Form1.Left + ((Form1.Width - frmHelp.Width) DIV 2);
  frmHelp.Top := Form1.Top + ((Form1.Height - frmHelp.Height) DIV 2);
  frmHelp.ShowModal;
end;

procedure TForm1.cmdHelpMouseEnter(Sender: TObject);
begin
  if panFilter.Visible = false then
    grpExplanation.Visible := true;
end;

procedure TForm1.cmdHelpMouseLeave(Sender: TObject);
begin
  grpExplanation.Visible := false;
end;

procedure TForm1.cmdInfoClick(Sender: TObject);
begin
  frmInfo.Left := Form1.Left + ((Form1.Width - frmInfo.Width) DIV 2);
  frmInfo.Top := Form1.Top + ((Form1.Height - frmInfo.Height) DIV 2);
  frmInfo.ShowModal;
end;

