{%mainunit umain.pas}

{ <Include-File for uMain - Section StatusBox Functions>
  <WoW Addon-Updater>

  Copyright (C) <2016> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

procedure StatusBoxEnable;
begin
  // Initialize StatusBox
  with Form1 do begin
    TimerStatusClose.Enabled := false;
    TimerAniRun.Enabled := true;
  end;

  {$IFDEF DARWIN} // Compiler-Switch for OS X
  with Form1 do begin
  {$ELSE}
  with frmStatus do begin
  {$ENDIF}
    lblStatus.Caption := '';
    lblAddonName.Caption := '';
    lblProgress.Caption := '';
  end;

  {$IFDEF DARWIN} // Compiler-Switch for OS X
  Form1.panStatus.Visible := true;
  {$ELSE}
  frmStatus.Show;
  {$ENDIF}
end;


procedure StatusBoxDisable;
begin
  {$IFDEF DARWIN} // Compiler-Switch for OS X
  Form1.panStatus.Visible := false;
  {$ELSE}
  frmStatus.Visible := false;
  frmStatus.Close;
  {$ENDIF}

  with Form1 do begin
    TimerAniRun.Enabled := false;
    TimerStatusClose.Enabled := false;
  end;
end;

procedure StatusBoxUpdate; // Size-Definition of StatusBox
var
    LabelMaxWidth: integer = 1;
    WinHeight: integer = 1;
    WinWidth: integer = 1;
    MaxWinWidth: integer = 600; // max. Size of StatusBox (should not be bigger as Main Form)
    LabelSize: array[0..2] of integer;

begin
   {$IFDEF DARWIN} // Compiler-Switch for OS X
   with Form1 do begin
   {$ELSE}
   with frmStatus do begin
   {$ENDIF}
     lblStatus.AutoSize := true;
     lblAddonName.AutoSize := true;
     lblProgress.AutoSize := true;

     LabelSize[0] := lblStatus.Width;
     LabelSize[1] := lblAddonName.Width;
     LabelSize[2] := lblProgress.Width;
     LabelMaxWidth := MaxValue(LabelSize);

     // If GnomeAnimations are switched off, make Animation invisible
     if GnomeAnimations = false then begin
       MaxWinWidth := 490;
       imgGnomeRun.AutoSize := false;
       imgGnomeRun.Constraints.MinWidth := 0;
       imgGnomeRun.Width := 0
     end
     else begin
       imgGnomeRun.AutoSize := true;
       imgGnomeRun.Constraints.MinWidth := 110
     end;

     WinHeight := imgGnomeRun.Top + imgGnomeRun.Height + imgGnomeRun.Top;

     // When Check/Update-Progress is running, width of StatusBox will be fixed to MaxWinWidth-Size
     // After finish (when TimerStatusClose is active), summary StatusBox will be sized dynamically
     if Form1.TimerStatusClose.Enabled = true then
       WinWidth := lblStatus.Left + LabelMaxWidth + imgGnomeRun.Left
     else
       WinWidth := MaxWinWidth;

     if WinWidth >= MaxWinWidth then begin
        if (lblStatus.Left + lblStatus.Width + imgGnomeRun.Left) >= MaxWinWidth then begin
           lblStatus.AutoSize := false;
           lblStatus.Width := MaxWinWidth - lblStatus.Left - imgGnomeRun.Left;
        end;
        if (lblStatus.Left + lblAddonName.Width + imgGnomeRun.Left) >= MaxWinWidth then begin
           lblAddonName.AutoSize := false;
           lblAddonName.Width := MaxWinWidth - lblStatus.Left - imgGnomeRun.Left;
        end;
        if (lblStatus.Left + lblProgress.Width + imgGnomeRun.Left) >= MaxWinWidth then begin
           lblProgress.AutoSize := false;
           lblProgress.Width := MaxWinWidth - lblStatus.Left - imgGnomeRun.Left;
        end;
        WinWidth := MaxWinWidth;
     end;

     {$IFDEF DARWIN} // Compiler-Switch for OS X
     panStatus.Height := WinHeight;
     panStatus.Width := WinWidth;
     {$ELSE}
     Height := WinHeight;
     Width := WinWidth;
     Left := Form1.Left + ((Form1.Width - Width) DIV 2);
     Top := Form1.Top + ((Form1.Height - Height) DIV 2);
     BorderStyle:= bsNone;
     Handle;
     CreateRoundedShape(Width, Height, frmStatus);
     {$ENDIF}
   end;
end;


