unit uAddNew;

{ <WoW Addon-Updater>
  <Dialog to find and add new Addons of this program>

  Copyright (C) <2018> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
    ExtCtrls, EditBtn, Buttons, Grids, ButtonPanel, uLanguage, simpleinternet,
    xquery, lclintf;

type

    { TfrmAddNew }

    TfrmAddNew = class(TForm)
        chkSearchEng: TCheckBox;
        chkDirectURL: TCheckBox;
        cmdAddAll: TBitBtn;
        cmdSearch: TBitBtn;
        ButtonPanel1: TButtonPanel;
        Panel1: TPanel;
        txtSearch: TEdit;
        grpSearch: TGroupBox;
        grpResult: TGroupBox;
        grpAddNew: TGroupBox;
        lblResults: TLabel;
        lblAddNew: TLabel;
        ListBox1: TListBox;
        Panel2: TPanel;
        RadioGroup1: TRadioGroup;
        Splitter1: TSplitter;
        StringGridResult: TStringGrid;
        procedure chkDirectURLChange(Sender: TObject);
        procedure cmdAddAllClick(Sender: TObject);
        procedure cmdSearchClick(Sender: TObject);
        procedure FormActivate(Sender: TObject);
        procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
        procedure FormResize(Sender: TObject);
        procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
            Shift: TShiftState; X, Y: Integer);
        procedure RadioGroup1SelectionChanged(Sender: TObject);
        procedure StringGridResultCheckboxToggled(sender: TObject; aCol,
            aRow: Integer; aState: TCheckboxState);
        procedure StringGridResultMouseDown(Sender: TObject;
            Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
        procedure StringGridResultMouseMove(Sender: TObject;
            Shift: TShiftState; X, Y: Integer);
        procedure StringGridResultPrepareCanvas(sender: TObject; aCol,
            aRow: Integer; aState: TGridDrawState);
        procedure txtSearchKeyPress(Sender: TObject; var Key: char);
    private
        { private declarations }
    public
        { public declarations }
    end;

procedure frmAddNewReset; // Reset Form to Standard Values
procedure frmAddNewSearchEnabled(S: boolean); // Turn Searchbox and Stringgrid on/off

var
    frmAddNew: TfrmAddNew;
    grpSizeSpacing: integer;
    SelEntries: integer;

implementation

uses
    uMain;

{$R *.lfm}

{ TfrmAddNew }

{$include uaddnew_formfunc.inc}
{$include uaddnew_listfunc.inc}
{$include uaddnew_search.inc}


end.

