unit uAddonChanges;

{ <WoW Addon-Updater>
  <Shows Information about Addon changes> 

  Copyright (C) <2017> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
    ExtCtrls, uLanguage, AddonUtils;

type

    { TfrmAddonChanges }

    TfrmAddonChanges = class(TForm)
        cmdOk: TButton;
        imgLogo: TImage;
        lblAddonURL: TLabel;
        lblAddonVersion: TLabel;
        lblShortVersionInfo: TLabel;
        lblAddonName: TLabel;
        memAddonChanges: TMemo;
        Panel1: TPanel;
        procedure FormActivate(Sender: TObject);
    private
        { private declarations }
    public
        { public declarations }
    end;

var
    frmAddonChanges: TfrmAddonChanges;

implementation

{$R *.lfm}

{ TfrmAddonChanges }

uses uMain;


procedure TfrmAddonChanges.FormActivate(Sender: TObject);
begin
  Caption := LangPMnuAddonChanges;
  lblAddonName.Caption := InfoDiaAddName;
  lblAddonVersion.Caption := InfoDiaAddVer;
  lblAddonURL.Caption := InfoDiaAddURL;
  lblShortVersionInfo.Caption := LangLblShortVersionInfo;

  memAddonChanges.Caption := LangRetrieve;

  Application.ProcessMessages;

  // Retrieve Addon Change Information from Addon Website...
  InfoDiaAddChanges := GetAddonChanges(InfoDiaAddURL);


  if Length(InfoDiaAddChanges) = 0 then
    memAddonChanges.Caption := LangNothingFound
  else begin
    memAddonChanges.Lines.BeginUpdate;
    memAddonChanges.Caption := InfoDiaAddChanges;
    memAddonChanges.Lines.EndUpdate
  end;
end;

end.

