unit uInfo;

{ <WoW Addon-Updater>
  <Informations about this program and GPL-license>

  Copyright (C) <2016> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  Buttons, StdCtrls, ExtCtrls, uLanguage, uActLog;

type

  { TfrmInfo }

  TfrmInfo = class(TForm)
    cmdOk: TButton;
    imgLogo: TImage;
    lblVersion: TLabel;
    memGPL: TMemo;
    memActLog: TMemo;
    memVersion: TMemo;
    memShortInfo: TMemo;
    PageControl1: TPageControl;
    TabTitleD: TTabSheet;
    TabTitleC: TTabSheet;
    TabTitleA: TTabSheet;
    TabTitleB: TTabSheet;
    procedure FormActivate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  frmInfo: TfrmInfo;

implementation

{$R *.lfm}

{ TfrmInfo }

procedure TfrmInfo.FormActivate(Sender: TObject);
begin
  frmInfo.Caption := LangMnuInfo;
  TabTitleA.Caption := LangInfoTabTitleA;
  TabTitleB.Caption := LangInfoTabTitleB;
  TabTitleC.Caption := LangInfoTabTitleC;
  TabTitleD.Caption := LangInfoTabTitleD;
  lblVersion.Caption := LangVersion;
  PageControl1.ActivePage := TabTitleA;

  memShortInfo.Lines.BeginUpdate;
    memShortInfo.Caption := LangShortInfo;
  memShortInfo.Lines.EndUpdate;

  memActLog.Lines.BeginUpdate;
    memActLog.Text := ActLog.Text;
  memActLog.Lines.EndUpdate;

  memGPL.Lines.BeginUpdate;
      memGPL.Text := '                    GNU GENERAL PUBLIC LICENSE' + #13#10 +
      '                       Version 3, 29 June 2007' + #13#10 +
      '' + #13#10 +
      ' Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>' + #13#10 +
      ' Everyone is permitted to copy and distribute verbatim copies' + #13#10 +
      ' of this license document, but changing it is not allowed.' + #13#10 +
      '' + #13#10 +
      '                            Preamble' + #13#10 +
      '' + #13#10 +
      '  The GNU General Public License is a free, copyleft license for' + #13#10 +
      'software and other kinds of works.' + #13#10 +
      '' + #13#10 +
      '  The licenses for most software and other practical works are designed' + #13#10 +
      'to take away your freedom to share and change the works.  By contrast,' + #13#10 +
      'the GNU General Public License is intended to guarantee your freedom to' + #13#10 +
      'share and change all versions of a program--to make sure it remains free' + #13#10 +
      'software for all its users.  We, the Free Software Foundation, use the' + #13#10 +
      'GNU General Public License for most of our software; it applies also to' + #13#10 +
      'any other work released this way by its authors.  You can apply it to' + #13#10 +
      'your programs, too.' + #13#10 +
      '' + #13#10 +
      '  When we speak of free software, we are referring to freedom, not' + #13#10 +
      'price.  Our General Public Licenses are designed to make sure that you' + #13#10 +
      'have the freedom to distribute copies of free software (and charge for' + #13#10 +
      'them if you wish), that you receive source code or can get it if you' + #13#10 +
      'want it, that you can change the software or use pieces of it in new' + #13#10 +
      'free programs, and that you know you can do these things.' + #13#10 +
      '' + #13#10 +
      '  To protect your rights, we need to prevent others from denying you' + #13#10 +
      'these rights or asking you to surrender the rights.  Therefore, you have' + #13#10 +
      'certain responsibilities if you distribute copies of the software, or if' + #13#10 +
      'you modify it: responsibilities to respect the freedom of others.' + #13#10 +
      '' + #13#10 +
      '  For example, if you distribute copies of such a program, whether' + #13#10 +
      'gratis or for a fee, you must pass on to the recipients the same' + #13#10 +
      'freedoms that you received.  You must make sure that they, too, receive' + #13#10 +
      'or can get the source code.  And you must show them these terms so they' + #13#10 +
      'know their rights.' + #13#10 +
      '' + #13#10 +
      '  Developers that use the GNU GPL protect your rights with two steps:' + #13#10 +
      '(1) assert copyright on the software, and (2) offer you this License' + #13#10 +
      'giving you legal permission to copy, distribute and/or modify it.' + #13#10 +
      '' + #13#10 +
      '  For the developers'' and authors'' protection, the GPL clearly explains' + #13#10 +
      'that there is no warranty for this free software.  For both users'' and' + #13#10 +
      'authors'' sake, the GPL requires that modified versions be marked as' + #13#10 +
      'changed, so that their problems will not be attributed erroneously to' + #13#10 +
      'authors of previous versions.' + #13#10 +
      '' + #13#10 +
      '  Some devices are designed to deny users access to install or run' + #13#10 +
      'modified versions of the software inside them, although the manufacturer' + #13#10 +
      'can do so.  This is fundamentally incompatible with the aim of' + #13#10 +
      'protecting users'' freedom to change the software.  The systematic' + #13#10 +
      'pattern of such abuse occurs in the area of products for individuals to' + #13#10 +
      'use, which is precisely where it is most unacceptable.  Therefore, we' + #13#10 +
      'have designed this version of the GPL to prohibit the practice for those' + #13#10 +
      'products.  If such problems arise substantially in other domains, we' + #13#10 +
      'stand ready to extend this provision to those domains in future versions' + #13#10 +
      'of the GPL, as needed to protect the freedom of users.' + #13#10 +
      '' + #13#10 +
      '  Finally, every program is threatened constantly by software patents.' + #13#10 +
      'States should not allow patents to restrict development and use of' + #13#10 +
      'software on general-purpose computers, but in those that do, we wish to' + #13#10 +
      'avoid the special danger that patents applied to a free program could' + #13#10 +
      'make it effectively proprietary.  To prevent this, the GPL assures that' + #13#10 +
      'patents cannot be used to render the program non-free.' + #13#10 +
      '' + #13#10 +
      '  The precise terms and conditions for copying, distribution and' + #13#10 +
      'modification follow.' + #13#10 +
      '' + #13#10 +
      '                       TERMS AND CONDITIONS' + #13#10 +
      '' + #13#10 +
      '  0. Definitions.' + #13#10 +
      '' + #13#10 +
      '  "This License" refers to version 3 of the GNU General Public License.' + #13#10 +
      '' + #13#10 +
      '  "Copyright" also means copyright-like laws that apply to other kinds of' + #13#10 +
      'works, such as semiconductor masks.' + #13#10 +
      '' + #13#10 +
      '  "The Program" refers to any copyrightable work licensed under this' + #13#10 +
      'License.  Each licensee is addressed as "you".  "Licensees" and' + #13#10 +
      '"recipients" may be individuals or organizations.' + #13#10 +
      '' + #13#10 +
      '  To "modify" a work means to copy from or adapt all or part of the work' + #13#10 +
      'in a fashion requiring copyright permission, other than the making of an' + #13#10 +
      'exact copy.  The resulting work is called a "modified version" of the' + #13#10 +
      'earlier work or a work "based on" the earlier work.' + #13#10 +
      '' + #13#10 +
      '  A "covered work" means either the unmodified Program or a work based' + #13#10 +
      'on the Program.' + #13#10 +
      '' + #13#10 +
      '  To "propagate" a work means to do anything with it that, without' + #13#10 +
      'permission, would make you directly or secondarily liable for' + #13#10 +
      'infringement under applicable copyright law, except executing it on a' + #13#10 +
      'computer or modifying a private copy.  Propagation includes copying,' + #13#10 +
      'distribution (with or without modification), making available to the' + #13#10 +
      'public, and in some countries other activities as well.' + #13#10 +
      '' + #13#10 +
      '  To "convey" a work means any kind of propagation that enables other' + #13#10 +
      'parties to make or receive copies.  Mere interaction with a user through' + #13#10 +
      'a computer network, with no transfer of a copy, is not conveying.' + #13#10 +
      '' + #13#10 +
      '  An interactive user interface displays "Appropriate Legal Notices"' + #13#10 +
      'to the extent that it includes a convenient and prominently visible' + #13#10 +
      'feature that (1) displays an appropriate copyright notice, and (2)' + #13#10 +
      'tells the user that there is no warranty for the work (except to the' + #13#10 +
      'extent that warranties are provided), that licensees may convey the' + #13#10 +
      'work under this License, and how to view a copy of this License.  If' + #13#10 +
      'the interface presents a list of user commands or options, such as a' + #13#10 +
      'menu, a prominent item in the list meets this criterion.' + #13#10 +
      '' + #13#10 +
      '  1. Source Code.' + #13#10 +
      '' + #13#10 +
      '  The "source code" for a work means the preferred form of the work' + #13#10 +
      'for making modifications to it.  "Object code" means any non-source' + #13#10 +
      'form of a work.' + #13#10 +
      '' + #13#10 +
      '  A "Standard Interface" means an interface that either is an official' + #13#10 +
      'standard defined by a recognized standards body, or, in the case of' + #13#10 +
      'interfaces specified for a particular programming language, one that' + #13#10 +
      'is widely used among developers working in that language.' + #13#10 +
      '' + #13#10 +
      '  The "System Libraries" of an executable work include anything, other' + #13#10 +
      'than the work as a whole, that (a) is included in the normal form of' + #13#10 +
      'packaging a Major Component, but which is not part of that Major' + #13#10 +
      'Component, and (b) serves only to enable use of the work with that' + #13#10 +
      'Major Component, or to implement a Standard Interface for which an' + #13#10 +
      'implementation is available to the public in source code form.  A' + #13#10 +
      '"Major Component", in this context, means a major essential component' + #13#10 +
      '(kernel, window system, and so on) of the specific operating system' + #13#10 +
      '(if any) on which the executable work runs, or a compiler used to' + #13#10 +
      'produce the work, or an object code interpreter used to run it.' + #13#10 +
      '' + #13#10 +
      '  The "Corresponding Source" for a work in object code form means all' + #13#10 +
      'the source code needed to generate, install, and (for an executable' + #13#10 +
      'work) run the object code and to modify the work, including scripts to' + #13#10 +
      'control those activities.  However, it does not include the work''s' + #13#10 +
      'System Libraries, or general-purpose tools or generally available free' + #13#10 +
      'programs which are used unmodified in performing those activities but' + #13#10 +
      'which are not part of the work.  For example, Corresponding Source' + #13#10 +
      'includes interface definition files associated with source files for' + #13#10 +
      'the work, and the source code for shared libraries and dynamically' + #13#10 +
      'linked subprograms that the work is specifically designed to require,' + #13#10 +
      'such as by intimate data communication or control flow between those' + #13#10 +
      'subprograms and other parts of the work.' + #13#10 +
      '' + #13#10 +
      '  The Corresponding Source need not include anything that users' + #13#10 +
      'can regenerate automatically from other parts of the Corresponding' + #13#10 +
      'Source.' + #13#10 +
      '' + #13#10 +
      '  The Corresponding Source for a work in source code form is that' + #13#10 +
      'same work.' + #13#10 +
      '' + #13#10 +
      '  2. Basic Permissions.' + #13#10 +
      '' + #13#10 +
      '  All rights granted under this License are granted for the term of' + #13#10 +
      'copyright on the Program, and are irrevocable provided the stated' + #13#10 +
      'conditions are met.  This License explicitly affirms your unlimited' + #13#10 +
      'permission to run the unmodified Program.  The output from running a' + #13#10 +
      'covered work is covered by this License only if the output, given its' + #13#10 +
      'content, constitutes a covered work.  This License acknowledges your' + #13#10 +
      'rights of fair use or other equivalent, as provided by copyright law.' + #13#10 +
      '' + #13#10 +
      '  You may make, run and propagate covered works that you do not' + #13#10 +
      'convey, without conditions so long as your license otherwise remains' + #13#10 +
      'in force.  You may convey covered works to others for the sole purpose' + #13#10 +
      'of having them make modifications exclusively for you, or provide you' + #13#10 +
      'with facilities for running those works, provided that you comply with' + #13#10 +
      'the terms of this License in conveying all material for which you do' + #13#10 +
      'not control copyright.  Those thus making or running the covered works' + #13#10 +
      'for you must do so exclusively on your behalf, under your direction' + #13#10 +
      'and control, on terms that prohibit them from making any copies of' + #13#10 +
      'your copyrighted material outside their relationship with you.' + #13#10 +
      '' + #13#10 +
      '  Conveying under any other circumstances is permitted solely under' + #13#10 +
      'the conditions stated below.  Sublicensing is not allowed; section 10' + #13#10 +
      'makes it unnecessary.' + #13#10 +
      '' + #13#10 +
      '  3. Protecting Users'' Legal Rights From Anti-Circumvention Law.' + #13#10 +
      '' + #13#10 +
      '  No covered work shall be deemed part of an effective technological' + #13#10 +
      'measure under any applicable law fulfilling obligations under article' + #13#10 +
      '11 of the WIPO copyright treaty adopted on 20 December 1996, or' + #13#10 +
      'similar laws prohibiting or restricting circumvention of such' + #13#10 +
      'measures.' + #13#10 +
      '' + #13#10 +
      '  When you convey a covered work, you waive any legal power to forbid' + #13#10 +
      'circumvention of technological measures to the extent such circumvention' + #13#10 +
      'is effected by exercising rights under this License with respect to' + #13#10 +
      'the covered work, and you disclaim any intention to limit operation or' + #13#10 +
      'modification of the work as a means of enforcing, against the work''s' + #13#10 +
      'users, your or third parties'' legal rights to forbid circumvention of' + #13#10 +
      'technological measures.' + #13#10 +
      '' + #13#10 +
      '  4. Conveying Verbatim Copies.' + #13#10 +
      '' + #13#10 +
      '  You may convey verbatim copies of the Program''s source code as you' + #13#10 +
      'receive it, in any medium, provided that you conspicuously and' + #13#10 +
      'appropriately publish on each copy an appropriate copyright notice;' + #13#10 +
      'keep intact all notices stating that this License and any' + #13#10 +
      'non-permissive terms added in accord with section 7 apply to the code;' + #13#10 +
      'keep intact all notices of the absence of any warranty; and give all' + #13#10 +
      'recipients a copy of this License along with the Program.' + #13#10 +
      '' + #13#10 +
      '  You may charge any price or no price for each copy that you convey,' + #13#10 +
      'and you may offer support or warranty protection for a fee.' + #13#10 +
      '' + #13#10 +
      '  5. Conveying Modified Source Versions.' + #13#10 +
      '' + #13#10 +
      '  You may convey a work based on the Program, or the modifications to' + #13#10 +
      'produce it from the Program, in the form of source code under the' + #13#10 +
      'terms of section 4, provided that you also meet all of these conditions:' + #13#10 +
      '' + #13#10 +
      '    a) The work must carry prominent notices stating that you modified' + #13#10 +
      '    it, and giving a relevant date.' + #13#10 +
      '' + #13#10 +
      '    b) The work must carry prominent notices stating that it is' + #13#10 +
      '    released under this License and any conditions added under section' + #13#10 +
      '    7.  This requirement modifies the requirement in section 4 to' + #13#10 +
      '    "keep intact all notices".' + #13#10 +
      '' + #13#10 +
      '    c) You must license the entire work, as a whole, under this' + #13#10 +
      '    License to anyone who comes into possession of a copy.  This' + #13#10 +
      '    License will therefore apply, along with any applicable section 7' + #13#10 +
      '    additional terms, to the whole of the work, and all its parts,' + #13#10 +
      '    regardless of how they are packaged.  This License gives no' + #13#10 +
      '    permission to license the work in any other way, but it does not' + #13#10 +
      '    invalidate such permission if you have separately received it.' + #13#10 +
      '' + #13#10 +
      '    d) If the work has interactive user interfaces, each must display' + #13#10 +
      '    Appropriate Legal Notices; however, if the Program has interactive' + #13#10 +
      '    interfaces that do not display Appropriate Legal Notices, your' + #13#10 +
      '    work need not make them do so.' + #13#10 +
      '' + #13#10 +
      '  A compilation of a covered work with other separate and independent' + #13#10 +
      'works, which are not by their nature extensions of the covered work,' + #13#10 +
      'and which are not combined with it such as to form a larger program,' + #13#10 +
      'in or on a volume of a storage or distribution medium, is called an' + #13#10 +
      '"aggregate" if the compilation and its resulting copyright are not' + #13#10 +
      'used to limit the access or legal rights of the compilation''s users' + #13#10 +
      'beyond what the individual works permit.  Inclusion of a covered work' + #13#10 +
      'in an aggregate does not cause this License to apply to the other' + #13#10 +
      'parts of the aggregate.' + #13#10 +
      '' + #13#10 +
      '  6. Conveying Non-Source Forms.' + #13#10 +
      '' + #13#10 +
      '  You may convey a covered work in object code form under the terms' + #13#10 +
      'of sections 4 and 5, provided that you also convey the' + #13#10 +
      'machine-readable Corresponding Source under the terms of this License,' + #13#10 +
      'in one of these ways:' + #13#10 +
      '' + #13#10 +
      '    a) Convey the object code in, or embodied in, a physical product' + #13#10 +
      '    (including a physical distribution medium), accompanied by the' + #13#10 +
      '    Corresponding Source fixed on a durable physical medium' + #13#10 +
      '    customarily used for software interchange.' + #13#10 +
      '' + #13#10 +
      '    b) Convey the object code in, or embodied in, a physical product' + #13#10 +
      '    (including a physical distribution medium), accompanied by a' + #13#10 +
      '    written offer, valid for at least three years and valid for as' + #13#10 +
      '    long as you offer spare parts or customer support for that product' + #13#10 +
      '    model, to give anyone who possesses the object code either (1) a' + #13#10 +
      '    copy of the Corresponding Source for all the software in the' + #13#10 +
      '    product that is covered by this License, on a durable physical' + #13#10 +
      '    medium customarily used for software interchange, for a price no' + #13#10 +
      '    more than your reasonable cost of physically performing this' + #13#10 +
      '    conveying of source, or (2) access to copy the' + #13#10 +
      '    Corresponding Source from a network server at no charge.' + #13#10 +
      '' + #13#10 +
      '    c) Convey individual copies of the object code with a copy of the' + #13#10 +
      '    written offer to provide the Corresponding Source.  This' + #13#10 +
      '    alternative is allowed only occasionally and noncommercially, and' + #13#10 +
      '    only if you received the object code with such an offer, in accord' + #13#10 +
      '    with subsection 6b.' + #13#10 +
      '' + #13#10 +
      '    d) Convey the object code by offering access from a designated' + #13#10 +
      '    place (gratis or for a charge), and offer equivalent access to the' + #13#10 +
      '    Corresponding Source in the same way through the same place at no' + #13#10 +
      '    further charge.  You need not require recipients to copy the' + #13#10 +
      '    Corresponding Source along with the object code.  If the place to' + #13#10 +
      '    copy the object code is a network server, the Corresponding Source' + #13#10 +
      '    may be on a different server (operated by you or a third party)' + #13#10 +
      '    that supports equivalent copying facilities, provided you maintain' + #13#10 +
      '    clear directions next to the object code saying where to find the' + #13#10 +
      '    Corresponding Source.  Regardless of what server hosts the' + #13#10 +
      '    Corresponding Source, you remain obligated to ensure that it is' + #13#10 +
      '    available for as long as needed to satisfy these requirements.' + #13#10 +
      '' + #13#10 +
      '    e) Convey the object code using peer-to-peer transmission, provided' + #13#10 +
      '    you inform other peers where the object code and Corresponding' + #13#10 +
      '    Source of the work are being offered to the general public at no' + #13#10 +
      '    charge under subsection 6d.' + #13#10 +
      '' + #13#10 +
      '  A separable portion of the object code, whose source code is excluded' + #13#10 +
      'from the Corresponding Source as a System Library, need not be' + #13#10 +
      'included in conveying the object code work.' + #13#10 +
      '' + #13#10 +
      '  A "User Product" is either (1) a "consumer product", which means any' + #13#10 +
      'tangible personal property which is normally used for personal, family,' + #13#10 +
      'or household purposes, or (2) anything designed or sold for incorporation' + #13#10 +
      'into a dwelling.  In determining whether a product is a consumer product,' + #13#10 +
      'doubtful cases shall be resolved in favor of coverage.  For a particular' + #13#10 +
      'product received by a particular user, "normally used" refers to a' + #13#10 +
      'typical or common use of that class of product, regardless of the status' + #13#10 +
      'of the particular user or of the way in which the particular user' + #13#10 +
      'actually uses, or expects or is expected to use, the product.  A product' + #13#10 +
      'is a consumer product regardless of whether the product has substantial' + #13#10 +
      'commercial, industrial or non-consumer uses, unless such uses represent' + #13#10 +
      'the only significant mode of use of the product.' + #13#10 +
      '' + #13#10 +
      '  "Installation Information" for a User Product means any methods,' + #13#10 +
      'procedures, authorization keys, or other information required to install' + #13#10 +
      'and execute modified versions of a covered work in that User Product from' + #13#10 +
      'a modified version of its Corresponding Source.  The information must' + #13#10 +
      'suffice to ensure that the continued functioning of the modified object' + #13#10 +
      'code is in no case prevented or interfered with solely because' + #13#10 +
      'modification has been made.' + #13#10 +
      '' + #13#10 +
      '  If you convey an object code work under this section in, or with, or' + #13#10 +
      'specifically for use in, a User Product, and the conveying occurs as' + #13#10 +
      'part of a transaction in which the right of possession and use of the' + #13#10 +
      'User Product is transferred to the recipient in perpetuity or for a' + #13#10 +
      'fixed term (regardless of how the transaction is characterized), the' + #13#10 +
      'Corresponding Source conveyed under this section must be accompanied' + #13#10 +
      'by the Installation Information.  But this requirement does not apply' + #13#10 +
      'if neither you nor any third party retains the ability to install' + #13#10 +
      'modified object code on the User Product (for example, the work has' + #13#10 +
      'been installed in ROM).' + #13#10 +
      '' + #13#10 +
      '  The requirement to provide Installation Information does not include a' + #13#10 +
      'requirement to continue to provide support service, warranty, or updates' + #13#10 +
      'for a work that has been modified or installed by the recipient, or for' + #13#10 +
      'the User Product in which it has been modified or installed.  Access to a' + #13#10 +
      'network may be denied when the modification itself materially and' + #13#10 +
      'adversely affects the operation of the network or violates the rules and' + #13#10 +
      'protocols for communication across the network.' + #13#10 +
      '' + #13#10 +
      '  Corresponding Source conveyed, and Installation Information provided,' + #13#10 +
      'in accord with this section must be in a format that is publicly' + #13#10 +
      'documented (and with an implementation available to the public in' + #13#10 +
      'source code form), and must require no special password or key for' + #13#10 +
      'unpacking, reading or copying.' + #13#10 +
      '' + #13#10 +
      '  7. Additional Terms.' + #13#10 +
      '' + #13#10 +
      '  "Additional permissions" are terms that supplement the terms of this' + #13#10 +
      'License by making exceptions from one or more of its conditions.' + #13#10 +
      'Additional permissions that are applicable to the entire Program shall' + #13#10 +
      'be treated as though they were included in this License, to the extent' + #13#10 +
      'that they are valid under applicable law.  If additional permissions' + #13#10 +
      'apply only to part of the Program, that part may be used separately' + #13#10 +
      'under those permissions, but the entire Program remains governed by' + #13#10 +
      'this License without regard to the additional permissions.' + #13#10 +
      '' + #13#10 +
      '  When you convey a copy of a covered work, you may at your option' + #13#10 +
      'remove any additional permissions from that copy, or from any part of' + #13#10 +
      'it.  (Additional permissions may be written to require their own' + #13#10 +
      'removal in certain cases when you modify the work.)  You may place' + #13#10 +
      'additional permissions on material, added by you to a covered work,' + #13#10 +
      'for which you have or can give appropriate copyright permission.' + #13#10 +
      '' + #13#10 +
      '  Notwithstanding any other provision of this License, for material you' + #13#10 +
      'add to a covered work, you may (if authorized by the copyright holders of' + #13#10 +
      'that material) supplement the terms of this License with terms:' + #13#10 +
      '' + #13#10 +
      '    a) Disclaiming warranty or limiting liability differently from the' + #13#10 +
      '    terms of sections 15 and 16 of this License; or' + #13#10 +
      '' + #13#10 +
      '    b) Requiring preservation of specified reasonable legal notices or' + #13#10 +
      '    author attributions in that material or in the Appropriate Legal' + #13#10 +
      '    Notices displayed by works containing it; or' + #13#10 +
      '' + #13#10 +
      '    c) Prohibiting misrepresentation of the origin of that material, or' + #13#10 +
      '    requiring that modified versions of such material be marked in' + #13#10 +
      '    reasonable ways as different from the original version; or' + #13#10 +
      '' + #13#10 +
      '    d) Limiting the use for publicity purposes of names of licensors or' + #13#10 +
      '    authors of the material; or' + #13#10 +
      '' + #13#10 +
      '    e) Declining to grant rights under trademark law for use of some' + #13#10 +
      '    trade names, trademarks, or service marks; or' + #13#10 +
      '' + #13#10 +
      '    f) Requiring indemnification of licensors and authors of that' + #13#10 +
      '    material by anyone who conveys the material (or modified versions of' + #13#10 +
      '    it) with contractual assumptions of liability to the recipient, for' + #13#10 +
      '    any liability that these contractual assumptions directly impose on' + #13#10 +
      '    those licensors and authors.' + #13#10 +
      '' + #13#10 +
      '  All other non-permissive additional terms are considered "further' + #13#10 +
      'restrictions" within the meaning of section 10.  If the Program as you' + #13#10 +
      'received it, or any part of it, contains a notice stating that it is' + #13#10 +
      'governed by this License along with a term that is a further' + #13#10 +
      'restriction, you may remove that term.  If a license document contains' + #13#10 +
      'a further restriction but permits relicensing or conveying under this' + #13#10 +
      'License, you may add to a covered work material governed by the terms' + #13#10 +
      'of that license document, provided that the further restriction does' + #13#10 +
      'not survive such relicensing or conveying.' + #13#10 +
      '' + #13#10 +
      '  If you add terms to a covered work in accord with this section, you' + #13#10 +
      'must place, in the relevant source files, a statement of the' + #13#10 +
      'additional terms that apply to those files, or a notice indicating' + #13#10 +
      'where to find the applicable terms.' + #13#10 +
      '' + #13#10 +
      '  Additional terms, permissive or non-permissive, may be stated in the' + #13#10 +
      'form of a separately written license, or stated as exceptions;' + #13#10 +
      'the above requirements apply either way.' + #13#10 +
      '' + #13#10 +
      '  8. Termination.' + #13#10 +
      '' + #13#10 +
      '  You may not propagate or modify a covered work except as expressly' + #13#10 +
      'provided under this License.  Any attempt otherwise to propagate or' + #13#10 +
      'modify it is void, and will automatically terminate your rights under' + #13#10 +
      'this License (including any patent licenses granted under the third' + #13#10 +
      'paragraph of section 11).' + #13#10 +
      '' + #13#10 +
      '  However, if you cease all violation of this License, then your' + #13#10 +
      'license from a particular copyright holder is reinstated (a)' + #13#10 +
      'provisionally, unless and until the copyright holder explicitly and' + #13#10 +
      'finally terminates your license, and (b) permanently, if the copyright' + #13#10 +
      'holder fails to notify you of the violation by some reasonable means' + #13#10 +
      'prior to 60 days after the cessation.' + #13#10 +
      '' + #13#10 +
      '  Moreover, your license from a particular copyright holder is' + #13#10 +
      'reinstated permanently if the copyright holder notifies you of the' + #13#10 +
      'violation by some reasonable means, this is the first time you have' + #13#10 +
      'received notice of violation of this License (for any work) from that' + #13#10 +
      'copyright holder, and you cure the violation prior to 30 days after' + #13#10 +
      'your receipt of the notice.' + #13#10 +
      '' + #13#10 +
      '  Termination of your rights under this section does not terminate the' + #13#10 +
      'licenses of parties who have received copies or rights from you under' + #13#10 +
      'this License.  If your rights have been terminated and not permanently' + #13#10 +
      'reinstated, you do not qualify to receive new licenses for the same' + #13#10 +
      'material under section 10.' + #13#10 +
      '' + #13#10 +
      '  9. Acceptance Not Required for Having Copies.' + #13#10 +
      '' + #13#10 +
      '  You are not required to accept this License in order to receive or' + #13#10 +
      'run a copy of the Program.  Ancillary propagation of a covered work' + #13#10 +
      'occurring solely as a consequence of using peer-to-peer transmission' + #13#10 +
      'to receive a copy likewise does not require acceptance.  However,' + #13#10 +
      'nothing other than this License grants you permission to propagate or' + #13#10 +
      'modify any covered work.  These actions infringe copyright if you do' + #13#10 +
      'not accept this License.  Therefore, by modifying or propagating a' + #13#10 +
      'covered work, you indicate your acceptance of this License to do so.' + #13#10 +
      '' + #13#10 +
      '  10. Automatic Licensing of Downstream Recipients.' + #13#10 +
      '' + #13#10 +
      '  Each time you convey a covered work, the recipient automatically' + #13#10 +
      'receives a license from the original licensors, to run, modify and' + #13#10 +
      'propagate that work, subject to this License.  You are not responsible' + #13#10 +
      'for enforcing compliance by third parties with this License.' + #13#10 +
      '' + #13#10 +
      '  An "entity transaction" is a transaction transferring control of an' + #13#10 +
      'organization, or substantially all assets of one, or subdividing an' + #13#10 +
      'organization, or merging organizations.  If propagation of a covered' + #13#10 +
      'work results from an entity transaction, each party to that' + #13#10 +
      'transaction who receives a copy of the work also receives whatever' + #13#10 +
      'licenses to the work the party''s predecessor in interest had or could' + #13#10 +
      'give under the previous paragraph, plus a right to possession of the' + #13#10 +
      'Corresponding Source of the work from the predecessor in interest, if' + #13#10 +
      'the predecessor has it or can get it with reasonable efforts.' + #13#10 +
      '' + #13#10 +
      '  You may not impose any further restrictions on the exercise of the' + #13#10 +
      'rights granted or affirmed under this License.  For example, you may' + #13#10 +
      'not impose a license fee, royalty, or other charge for exercise of' + #13#10 +
      'rights granted under this License, and you may not initiate litigation' + #13#10 +
      '(including a cross-claim or counterclaim in a lawsuit) alleging that' + #13#10 +
      'any patent claim is infringed by making, using, selling, offering for' + #13#10 +
      'sale, or importing the Program or any portion of it.' + #13#10 +
      '' + #13#10 +
      '  11. Patents.' + #13#10 +
      '' + #13#10 +
      '  A "contributor" is a copyright holder who authorizes use under this' + #13#10 +
      'License of the Program or a work on which the Program is based.  The' + #13#10 +
      'work thus licensed is called the contributor''s "contributor version".' + #13#10 +
      '' + #13#10 +
      '  A contributor''s "essential patent claims" are all patent claims' + #13#10 +
      'owned or controlled by the contributor, whether already acquired or' + #13#10 +
      'hereafter acquired, that would be infringed by some manner, permitted' + #13#10 +
      'by this License, of making, using, or selling its contributor version,' + #13#10 +
      'but do not include claims that would be infringed only as a' + #13#10 +
      'consequence of further modification of the contributor version.  For' + #13#10 +
      'purposes of this definition, "control" includes the right to grant' + #13#10 +
      'patent sublicenses in a manner consistent with the requirements of' + #13#10 +
      'this License.' + #13#10 +
      '' + #13#10 +
      '  Each contributor grants you a non-exclusive, worldwide, royalty-free' + #13#10 +
      'patent license under the contributor''s essential patent claims, to' + #13#10 +
      'make, use, sell, offer for sale, import and otherwise run, modify and' + #13#10 +
      'propagate the contents of its contributor version.' + #13#10 +
      '' + #13#10 +
      '  In the following three paragraphs, a "patent license" is any express' + #13#10 +
      'agreement or commitment, however denominated, not to enforce a patent' + #13#10 +
      '(such as an express permission to practice a patent or covenant not to' + #13#10 +
      'sue for patent infringement).  To "grant" such a patent license to a' + #13#10 +
      'party means to make such an agreement or commitment not to enforce a' + #13#10 +
      'patent against the party.' + #13#10 +
      '' + #13#10 +
      '  If you convey a covered work, knowingly relying on a patent license,' + #13#10 +
      'and the Corresponding Source of the work is not available for anyone' + #13#10 +
      'to copy, free of charge and under the terms of this License, through a' + #13#10 +
      'publicly available network server or other readily accessible means,' + #13#10 +
      'then you must either (1) cause the Corresponding Source to be so' + #13#10 +
      'available, or (2) arrange to deprive yourself of the benefit of the' + #13#10 +
      'patent license for this particular work, or (3) arrange, in a manner' + #13#10 +
      'consistent with the requirements of this License, to extend the patent' + #13#10 +
      'license to downstream recipients.  "Knowingly relying" means you have' + #13#10 +
      'actual knowledge that, but for the patent license, your conveying the' + #13#10 +
      'covered work in a country, or your recipient''s use of the covered work' + #13#10 +
      'in a country, would infringe one or more identifiable patents in that' + #13#10 +
      'country that you have reason to believe are valid.' + #13#10 +
      '' + #13#10 +
      '  If, pursuant to or in connection with a single transaction or' + #13#10 +
      'arrangement, you convey, or propagate by procuring conveyance of, a' + #13#10 +
      'covered work, and grant a patent license to some of the parties' + #13#10 +
      'receiving the covered work authorizing them to use, propagate, modify' + #13#10 +
      'or convey a specific copy of the covered work, then the patent license' + #13#10 +
      'you grant is automatically extended to all recipients of the covered' + #13#10 +
      'work and works based on it.' + #13#10 +
      '' + #13#10 +
      '  A patent license is "discriminatory" if it does not include within' + #13#10 +
      'the scope of its coverage, prohibits the exercise of, or is' + #13#10 +
      'conditioned on the non-exercise of one or more of the rights that are' + #13#10 +
      'specifically granted under this License.  You may not convey a covered' + #13#10 +
      'work if you are a party to an arrangement with a third party that is' + #13#10 +
      'in the business of distributing software, under which you make payment' + #13#10 +
      'to the third party based on the extent of your activity of conveying' + #13#10 +
      'the work, and under which the third party grants, to any of the' + #13#10 +
      'parties who would receive the covered work from you, a discriminatory' + #13#10 +
      'patent license (a) in connection with copies of the covered work' + #13#10 +
      'conveyed by you (or copies made from those copies), or (b) primarily' + #13#10 +
      'for and in connection with specific products or compilations that' + #13#10 +
      'contain the covered work, unless you entered into that arrangement,' + #13#10 +
      'or that patent license was granted, prior to 28 March 2007.' + #13#10 +
      '' + #13#10 +
      '  Nothing in this License shall be construed as excluding or limiting' + #13#10 +
      'any implied license or other defenses to infringement that may' + #13#10 +
      'otherwise be available to you under applicable patent law.' + #13#10 +
      '' + #13#10 +
      '  12. No Surrender of Others'' Freedom.' + #13#10 +
      '' + #13#10 +
      '  If conditions are imposed on you (whether by court order, agreement or' + #13#10 +
      'otherwise) that contradict the conditions of this License, they do not' + #13#10 +
      'excuse you from the conditions of this License.  If you cannot convey a' + #13#10 +
      'covered work so as to satisfy simultaneously your obligations under this' + #13#10 +
      'License and any other pertinent obligations, then as a consequence you may' + #13#10 +
      'not convey it at all.  For example, if you agree to terms that obligate you' + #13#10 +
      'to collect a royalty for further conveying from those to whom you convey' + #13#10 +
      'the Program, the only way you could satisfy both those terms and this' + #13#10 +
      'License would be to refrain entirely from conveying the Program.' + #13#10 +
      '' + #13#10 +
      '  13. Use with the GNU Affero General Public License.' + #13#10 +
      '' + #13#10 +
      '  Notwithstanding any other provision of this License, you have' + #13#10 +
      'permission to link or combine any covered work with a work licensed' + #13#10 +
      'under version 3 of the GNU Affero General Public License into a single' + #13#10 +
      'combined work, and to convey the resulting work.  The terms of this' + #13#10 +
      'License will continue to apply to the part which is the covered work,' + #13#10 +
      'but the special requirements of the GNU Affero General Public License,' + #13#10 +
      'section 13, concerning interaction through a network will apply to the' + #13#10 +
      'combination as such.' + #13#10 +
      '' + #13#10 +
      '  14. Revised Versions of this License.' + #13#10 +
      '' + #13#10 +
      '  The Free Software Foundation may publish revised and/or new versions of' + #13#10 +
      'the GNU General Public License from time to time.  Such new versions will' + #13#10 +
      'be similar in spirit to the present version, but may differ in detail to' + #13#10 +
      'address new problems or concerns.' + #13#10 +
      '' + #13#10 +
      '  Each version is given a distinguishing version number.  If the' + #13#10 +
      'Program specifies that a certain numbered version of the GNU General' + #13#10 +
      'Public License "or any later version" applies to it, you have the' + #13#10 +
      'option of following the terms and conditions either of that numbered' + #13#10 +
      'version or of any later version published by the Free Software' + #13#10 +
      'Foundation.  If the Program does not specify a version number of the' + #13#10 +
      'GNU General Public License, you may choose any version ever published' + #13#10 +
      'by the Free Software Foundation.' + #13#10 +
      '' + #13#10 +
      '  If the Program specifies that a proxy can decide which future' + #13#10 +
      'versions of the GNU General Public License can be used, that proxy''s' + #13#10 +
      'public statement of acceptance of a version permanently authorizes you' + #13#10 +
      'to choose that version for the Program.' + #13#10 +
      '' + #13#10 +
      '  Later license versions may give you additional or different' + #13#10 +
      'permissions.  However, no additional obligations are imposed on any' + #13#10 +
      'author or copyright holder as a result of your choosing to follow a' + #13#10 +
      'later version.' + #13#10 +
      '' + #13#10 +
      '  15. Disclaimer of Warranty.' + #13#10 +
      '' + #13#10 +
      '  THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY' + #13#10 +
      'APPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT' + #13#10 +
      'HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY' + #13#10 +
      'OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,' + #13#10 +
      'THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR' + #13#10 +
      'PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM' + #13#10 +
      'IS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF' + #13#10 +
      'ALL NECESSARY SERVICING, REPAIR OR CORRECTION.' + #13#10 +
      '' + #13#10 +
      '  16. Limitation of Liability.' + #13#10 +
      '' + #13#10 +
      '  IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING' + #13#10 +
      'WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS' + #13#10 +
      'THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY' + #13#10 +
      'GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE' + #13#10 +
      'USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF' + #13#10 +
      'DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD' + #13#10 +
      'PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),' + #13#10 +
      'EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF' + #13#10 +
      'SUCH DAMAGES.' + #13#10 +
      '' + #13#10 +
      '  17. Interpretation of Sections 15 and 16.' + #13#10 +
      '' + #13#10 +
      '  If the disclaimer of warranty and limitation of liability provided' + #13#10 +
      'above cannot be given local legal effect according to their terms,' + #13#10 +
      'reviewing courts shall apply local law that most closely approximates' + #13#10 +
      'an absolute waiver of all civil liability in connection with the' + #13#10 +
      'Program, unless a warranty or assumption of liability accompanies a' + #13#10 +
      'copy of the Program in return for a fee.' + #13#10 +
      '' + #13#10 +
      '                     END OF TERMS AND CONDITIONS' + #13#10 +
      '' + #13#10 +
      '            How to Apply These Terms to Your New Programs' + #13#10 +
      '' + #13#10 +
      '  If you develop a new program, and you want it to be of the greatest' + #13#10 +
      'possible use to the public, the best way to achieve this is to make it' + #13#10 +
      'free software which everyone can redistribute and change under these terms.' + #13#10 +
      '' + #13#10 +
      '  To do so, attach the following notices to the program.  It is safest' + #13#10 +
      'to attach them to the start of each source file to most effectively' + #13#10 +
      'state the exclusion of warranty; and each file should have at least' + #13#10 +
      'the "copyright" line and a pointer to where the full notice is found.' + #13#10 +
      '' + #13#10 +
      '    <one line to give the program''s name and a brief idea of what it does.>' + #13#10 +
      '    Copyright (C) <year>  <name of author>' + #13#10 +
      '' + #13#10 +
      '    This program is free software: you can redistribute it and/or modify' + #13#10 +
      '    it under the terms of the GNU General Public License as published by' + #13#10 +
      '    the Free Software Foundation, either version 3 of the License, or' + #13#10 +
      '    (at your option) any later version.' + #13#10 +
      '' + #13#10 +
      '    This program is distributed in the hope that it will be useful,' + #13#10 +
      '    but WITHOUT ANY WARRANTY; without even the implied warranty of' + #13#10 +
      '    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the' + #13#10 +
      '    GNU General Public License for more details.' + #13#10 +
      '' + #13#10 +
      '    You should have received a copy of the GNU General Public License' + #13#10 +
      '    along with this program.  If not, see <http://www.gnu.org/licenses/>.' + #13#10 +
      '' + #13#10 +
      'Also add information on how to contact you by electronic and paper mail.' + #13#10 +
      '' + #13#10 +
      '  If the program does terminal interaction, make it output a short' + #13#10 +
      'notice like this when it starts in an interactive mode:' + #13#10 +
      '' + #13#10 +
      '    <program>  Copyright (C) <year>  <name of author>' + #13#10 +
      '    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w''.' + #13#10 +
      '    This is free software, and you are welcome to redistribute it' + #13#10 +
      '    under certain conditions; type `show c'' for details.' + #13#10 +
      '' + #13#10 +
      'The hypothetical commands `show w'' and `show c'' should show the appropriate' + #13#10 +
      'parts of the General Public License.  Of course, your program''s commands' + #13#10 +
      'might be different; for a GUI interface, you would use an "about box".' + #13#10 +
      '' + #13#10 +
      '  You should also get your employer (if you work as a programmer) or school,' + #13#10 +
      'if any, to sign a "copyright disclaimer" for the program, if necessary.' + #13#10 +
      'For more information on this, and how to apply and follow the GNU GPL, see' + #13#10 +
      '<http://www.gnu.org/licenses/>.' + #13#10 +
      '' + #13#10 +
      '  The GNU General Public License does not permit incorporating your program' + #13#10 +
      'into proprietary programs.  If your program is a subroutine library, you' + #13#10 +
      'may consider it more useful to permit linking proprietary applications with' + #13#10 +
      'the library.  If this is what you want to do, use the GNU Lesser General' + #13#10 +
      'Public License instead of this License.  But first, please read' + #13#10 +
      '<http://www.gnu.org/philosophy/why-not-lgpl.html>.';
  memGPL.Lines.EndUpdate;

  memVersion.Lines.BeginUpdate;
    memVersion.Caption := LangVersionInfo;
  memVersion.Lines.EndUpdate;
end;

end.

