unit uUtils;

{ <WoW Addon-Updater>
  <Additional Functions and Utilities>

  Copyright (C) <2016> <Arndt Braier> <dev@braier.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
}

{$mode objfpc}{$H+}

interface

uses
    Classes, SysUtils, Controls, Graphics;

// CreateRoundedShape -> Used to create forms with rounded corners under Win and Linux
// Actually no effects in OS X
procedure CreateRoundedShape(AWid,AHei:integer; AControl:TWinControl);

// Function to repeat chars
function RepeatChar(ch: char; count: integer): string;


implementation

procedure CreateRoundedShape(AWid,AHei:integer; AControl:TWinControl);
const
  R = 27;
var
  bmp:TBitmap;

begin
   bmp:=TBitmap.Create;
   try
     bmp.PixelFormat:=pf1bit;
     bmp.SetSize(AControl.Width, AControl.Height);

     bmp.Canvas.Pen.Style:=psSolid;
     bmp.Canvas.Brush.Style:=bsSolid;

     bmp.Canvas.Brush.Color:=clBlack;
     bmp.Canvas.FillRect(0,0,bmp.Width,bmp.Height);

     bmp.Canvas.Brush.Color:=clWhite;
     bmp.Canvas.Pen.Color:=clWhite;
     bmp.Canvas.RoundRect(0,0,bmp.Width,bmp.Height,R,R);

     AControl.SetShape(bmp);
   finally
     bmp.Free;
   end;
end;


function RepeatChar(ch: char; count: integer): string;
begin
  SetLength(Result,count);
  if Length(Result)>0 then
    FillChar(Result[1],Length(Result),ch);
end;


end.

